%global debug_package   %{nil}
%global provider        github
%global provider_tld    com
%global project         gogo
%global repo            protobuf
%global import_path     %{provider}.%{provider_tld}/%{project}/%{repo}
%global nname           golang-github-gogo-protobuf

%global commit          bc946d07d1016848dfd2507f90f0859c9471681e
%global shortcommit     %(c=%{commit}; echo ${c:0:7})

%global g_import_path   code.google.com/p/gogoprotobuf

Name:           golang-googlecode-gogoprotobuf
Version:        0
Release:        0.10.git%{shortcommit}%{?dist}
Summary:        A fork of goprotobuf with several extra features
License:        BSD
URL:            http://%{import_path}
Source0:        https://github.com/%{project}/%{repo}/archive/%{commit}/%{repo}-%{shortcommit}.tar.gz
BuildRequires:  golang >= 1.2.1-3
ExclusiveArch:  %{ix86} x86_64 %{arm}
Requires:       protobuf

%description
%{summary}

%package -n %{nname}-devel
BuildRequires:  golang >= 1.2.1-3
Requires:       golang >= 1.2.1-3
Requires:       %{name}
Summary:        %{summary}
Provides:       golang(%{import_path}/dockertest/gogodocker-gen) = %{version}-%{release}
Provides:       golang(%{import_path}/fieldpath) = %{version}-%{release}
Provides:       golang(%{import_path}/fieldpath/fieldpath-gen) = %{version}-%{release}
Provides:       golang(%{import_path}/gogoproto) = %{version}-%{release}
Provides:       golang(%{import_path}/io) = %{version}-%{release}
Provides:       golang(%{import_path}/parser) = %{version}-%{release}
Provides:       golang(%{import_path}/pbpath) = %{version}-%{release}
Provides:       golang(%{import_path}/plugin/defaultcheck) = %{version}-%{release}
Provides:       golang(%{import_path}/plugin/description) = %{version}-%{release}
Provides:       golang(%{import_path}/plugin/embedcheck) = %{version}-%{release}
Provides:       golang(%{import_path}/plugin/enumstringer) = %{version}-%{release}
Provides:       golang(%{import_path}/plugin/equal) = %{version}-%{release}
Provides:       golang(%{import_path}/plugin/face) = %{version}-%{release}
Provides:       golang(%{import_path}/plugin/gostring) = %{version}-%{release}
Provides:       golang(%{import_path}/plugin/marshalto) = %{version}-%{release}
Provides:       golang(%{import_path}/plugin/populate) = %{version}-%{release}
Provides:       golang(%{import_path}/plugin/size) = %{version}-%{release}
Provides:       golang(%{import_path}/plugin/stringer) = %{version}-%{release}
Provides:       golang(%{import_path}/plugin/testgen) = %{version}-%{release}
Provides:       golang(%{import_path}/plugin/union) = %{version}-%{release}
Provides:       golang(%{import_path}/plugin/unmarshal) = %{version}-%{release}
Provides:       golang(%{import_path}/proto) = %{version}-%{release}
Provides:       golang(%{import_path}/protoc-gen-gogo) = %{version}-%{release}
Provides:       golang(%{import_path}/protoc-gen-gogo/descriptor) = %{version}-%{release}
Provides:       golang(%{import_path}/protoc-gen-gogo/generator) = %{version}-%{release}
Provides:       golang(%{import_path}/protoc-gen-gogo/plugin) = %{version}-%{release}
Provides:       golang(%{import_path}/protoc-gen-gogo/version) = %{version}-%{release}

%package devel
BuildRequires:  golang >= 1.2.1-3
Requires:       golang >= 1.2.1-3
Requires:       %{name}
Summary:        %{summary}
Provides:       golang(%{g_import_path}/dockertest/gogodocker-gen) = %{version}-%{release}
Provides:       golang(%{g_import_path}/fieldpath) = %{version}-%{release}
Provides:       golang(%{g_import_path}/fieldpath/fieldpath-gen) = %{version}-%{release}
Provides:       golang(%{g_import_path}/gogoproto) = %{version}-%{release}
Provides:       golang(%{g_import_path}/io) = %{version}-%{release}
Provides:       golang(%{g_import_path}/parser) = %{version}-%{release}
Provides:       golang(%{g_import_path}/pbpath) = %{version}-%{release}
Provides:       golang(%{g_import_path}/plugin/defaultcheck) = %{version}-%{release}
Provides:       golang(%{g_import_path}/plugin/description) = %{version}-%{release}
Provides:       golang(%{g_import_path}/plugin/embedcheck) = %{version}-%{release}
Provides:       golang(%{g_import_path}/plugin/enumstringer) = %{version}-%{release}
Provides:       golang(%{g_import_path}/plugin/equal) = %{version}-%{release}
Provides:       golang(%{g_import_path}/plugin/face) = %{version}-%{release}
Provides:       golang(%{g_import_path}/plugin/gostring) = %{version}-%{release}
Provides:       golang(%{g_import_path}/plugin/marshalto) = %{version}-%{release}
Provides:       golang(%{g_import_path}/plugin/populate) = %{version}-%{release}
Provides:       golang(%{g_import_path}/plugin/size) = %{version}-%{release}
Provides:       golang(%{g_import_path}/plugin/stringer) = %{version}-%{release}
Provides:       golang(%{g_import_path}/plugin/testgen) = %{version}-%{release}
Provides:       golang(%{g_import_path}/plugin/union) = %{version}-%{release}
Provides:       golang(%{g_import_path}/plugin/unmarshal) = %{version}-%{release}
Provides:       golang(%{g_import_path}/proto) = %{version}-%{release}
Provides:       golang(%{g_import_path}/protoc-gen-gogo) = %{version}-%{release}
Provides:       golang(%{g_import_path}/protoc-gen-gogo/descriptor) = %{version}-%{release}
Provides:       golang(%{g_import_path}/protoc-gen-gogo/generator) = %{version}-%{release}
Provides:       golang(%{g_import_path}/protoc-gen-gogo/plugin) = %{version}-%{release}
Provides:       golang(%{g_import_path}/protoc-gen-gogo/version) = %{version}-%{release}

%description devel
%{summary}

%description -n %{nname}-devel
%{summary}

%prep
%setup -q -n %{repo}-%{commit}

%build
unset GOPATH
export GOPATH=$(pwd)
mkdir -p src/github.com/gogo/
ln -s ../../../ src/github.com/gogo/protobuf
cd protoc-gen-gogo
go build

%install
#### binary ####
install -d %{buildroot}%{_bindir}
install -m 755 protoc-gen-gogo/protoc-gen-gogo %{buildroot}/%{_bindir}/protoc-gen-gogo
rm -rf proto/testdata protoc-gen-gogo/{protoc-gen-gogo,testdata} fieldpath/fieldpath-gen

#### devel ####
mkdir -p %{buildroot}/%{gopath}/src/%{import_path}
mkdir -p %{buildroot}/%{gopath}/src/%{g_import_path}

for d in fieldpath io parser plugin proto protoc-gen-gogo; do
   cp -pav $d %{buildroot}/%{gopath}/src/%{import_path}
   cp -pav $d %{buildroot}/%{gopath}/src/%{g_import_path}
   find %{buildroot}/%{gopath}/ -name Makefile -delete
done

cd %{buildroot}/%{gopath}/src/%{g_import_path}/
# github.com/gogo/protobuf -> code.google.com/p/gogoprotobuf
sed -i 's/"github\.com\/gogo\/protobuf/"code\.google\.com\/p\/gogoprotobuf/g' \
        $(find . -name '*.go')

%files 
%doc CONTRIBUTORS LICENSE README
%{_bindir}/protoc-gen-gogo

%files -n %{nname}-devel
%doc CONTRIBUTORS LICENSE README
%dir %{gopath}/src/%{provider}.%{provider_tld}/%{project}
%{gopath}/src/%{import_path}

%files devel
%doc CONTRIBUTORS LICENSE README
%{gopath}/src/%{g_import_path}



%changelog
* Fri Feb 13 2015 jchaloup <jchaloup@redhat.com> - 0-0.10.gitbc946d0
- Bump to upstream bc946d07d1016848dfd2507f90f0859c9471681e
  import path has changed -> add devel package to keep back compatibility
  with code.google.com/p/gogoprotobuf import paths

* Fri Sep 19 2014 Lokesh Mandvekar <lsm5@fedoraproject.org> - 0-0.8.gitd228c1a
- preserve timestamps
- don't own golang dirs
- don't redifine gopath
- ExcluseBuild for goarches

* Thu Jul 17 2014 Colin Walters <walters@verbum.org> - 0-0.7.gitd228c1a
- Initial package
